
#include "../melee.h"
#include "../ais.h"

//////////////// States of this AI ///////////////
#define AI_CHASE       1
#define AI_ATTACK      2
#define AI_RECHARGE    3
//////////////////////////////////////////////////
AI_Player_Slylandro::AI_Player_Slylandro(Ship *ai) :
  AI_Player(ai) {

 select_state = true;
}

void AI_Player_Slylandro::calculate() 
{
 AI_Player::calculate(); //Turn off all 'keys'
 k.thrust       = true;

 if (ai_ship->target==NULL) {
     Stop();
     return;
  }

   switch (state) {
    case AI_CHASE:
                    Chase(ai_ship->target);
                    break;
    case AI_ATTACK:
                    Attack(ai_ship->target);
                    break;
    case AI_RECHARGE:
                    if (ai_ship->batt>0)
                     select_state = true;
                    SpaceObject *space_obj;
                    space_obj = spaceFrame->getFirstObject(LAYER_CBODIES);
                    if (space_obj!=NULL) Chase(space_obj);
                    k.fire_special = true;
                    break;
    default: break;
 } 

 CheckShots();
 if (select_state) change_state();
}
void AI_Player_Slylandro::ProcessShot(SpaceLocation *shot, double range)
{

 if (range >= 550.0) return;
 if (!isTarget(shot)) return;
 
 Evade(shot);
 select_state = true; 
}

void AI_Player_Slylandro::change_state() 
{

double range = ai_ship->distance(ai_ship->target);

 if (range > 550.0 ) 
   state = AI_CHASE;
 else 
   state = AI_ATTACK;
 
 if (ai_ship->batt==0)
   state = AI_RECHARGE;

 select_state = false; 
}
