#include <string.h>
#include <allegro.h>
#include "melee.h"
#include "melee/mship.h"
#include "libs.h"

#ifndef NO_ALLEGRO_4
char *key_string[128] = {
   "(none)",     "A",          "B",          "C",
   "D",          "E",          "F",          "G",
   "H",          "I",          "J",          "K",
   "L",          "M",          "N",          "O",
   "P",          "Q",          "R",          "S",
   "T",          "U",          "V",          "W",
   "X",          "Y",          "Z",          "0",
   "1",          "2",          "3",          "4",
   "5",          "6",          "7",          "8",
   "9",          "0_PAD",      "1_PAD",      "2_PAD",
   "3_PAD",      "4_PAD",      "5_PAD",      "6_PAD",
   "7_PAD",      "8_PAD",      "9_PAD",      "F1",
   "F2",         "F3",         "F4",         "F5",
   "F6",         "F7",         "F8",         "F9",
   "F10",        "F11",        "F12",        "ESC",
   "TILDE",      "MINUS",      "EQUALS",     "BACKSPACE",
   "TAB",        "OPENBRACE",  "CLOSEBRACE", "ENTER",
   "COLON",      "QUOTE",      "BACKSLASH",  "BACKSLASH2",
   "COMMA",      "STOP",       "SLASH",      "SPACE",
   "INSERT",     "DEL",        "HOME",       "END",
   "PGUP",       "PGDN",       "LEFT",       "RIGHT",
   "UP",         "DOWN",       "SLASH_PAD",  "ASTERISK",
   "MINUS_PAD",  "PLUS_PAD",   "DEL_PAD",    "ENTER_PAD",
   "PRTSCR",     "PAUSE",      "YEN",        "YEN2",
   "LSHIFT",     "RSHIFT",     "LCONTROL",   "RCONTROL",
   "ALT",        "ALTGR",      "LWIN",       "RWIN",
   "MENU",       "SCRLOCK",    "NUMLOCK",    "CAPSLOCK",
   "MAX",         NULL
	};
#else
char *key_string[256] = {
		"(none)",     "ESC",        "1",          "2",					// 0-3*
		"3",          "4",          "5",          "6",					// 4-7
		"7",          "8",          "9",          "0",					// 8-11
		"MINUS",      "EQUALS",     "BACKSPACE",  "TAB",				//12-15
		"Q",          "W",          "E",          "R",					//16-19*
		"T",          "Y",          "U",          "I",					//20-23
		"O",          "P",          "OPENBRACE",  "CLOSEBRACE",	//24-27
		"ENTER",      "RCONTROL",   "A",          "S",					//28-31
		"D",          "F",          "G",          "H",					//32-35*
		"J",          "K",          "L",          "COLON",			//36-39
		"QUOTE",      "TILDE",     "LSHIFT",     "BACKSLASH",		//40-43
		"Z",          "X",          "C",          "V",					//44-47
		"B",          "N",          "M",          "COMMA",			//48-51*
		"STOP",       "SLASH",      "RSHIFT",     "ASTERISK",		//52-55
		"SLASH_PAD",  "SPACE",      "CAPSLOCK",   "F1",					//56-59
		"F2",         "F3",         "F4",         "F5",					//60-63
		"F6",         "F7",         "F8",         "F9",					//64-67*
		"F10",        "(none)",     "(none)",     "7_PAD",			//68-71
		"8_PAD",			"9_PAD",      "(none)",     "4_PAD",			//72-75
		"5_PAD",      "6_PAD",      "PLUS_PAD",   "1_PAD",			//76-79
		"DOWN",       "PGDN",       "INS_PAD",    "DEL_PAD",		//80-83*
		"(none)",     "(none)",     "(none)",     "F11",				//84-87
		"F12",        "(none)",     "(none)",     "(none)",			//88-91
		"(none)",     "(none)",     "(none)",     "(none)",			//92-94
		"(none)",     "(none)",     "(none)",     "(none)",			//96-99*
		"(none)",     "(none)",     "(none)",     "(none)",			//100-103
		"(none)",     "(none)",     "(none)",     "(none)",			//104-107
		"(none)",     "(none)",     "(none)",     "(none)",			//108-111
		"(none)",     "(none)",     "(none)",     "(none)",			//112-115*
		"(none)",     "(none)",     "(none)",     "(none)",			//116-119
		"(none)",     "(none)",     "(none)",     "(none)",			//120-123
		"(none)",     "(none)",     "(none)",     "(none)",			//124-127
		"(none)",     "(none)",     "(none)",     "(none)",			//128-131*
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "(none)",     "(none)",			//144*
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"ENTER_PAD",  "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "(none)",     "(none)",			//160*
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "(none)",     "(none)",			//176*
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"ALTGR",      "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "(none)",     "(none)",			//192*
		"(none)",     "(none)",     "(none)",     "HOME",			//
		"UP",         "PGUP",       "(none)",     "LEFT",			//
		"(none)",     "RIGHT",      "(none)",     "END",			//
		"DOWN",       "PGDN",       "INSERT",     "DELETE",			//208*
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "(none)",     "(none)",			//224*
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "(none)",     "(none)",			//240*
		"(none)",     "(none)",     "(none)",     "(none)",			//
		"(none)",     "(none)",     "SLASH_PAD",  "(none)",			//
		"(none)",     "(none)",     "(none)",     "NULL",			//
		};
#endif

int key_num(const char *name) {
	int i = 0;
	if (!name) return 0;
	while (true) {
		if (!key_string[i]) return 0;
		if (!strcmp(name, key_string[i])) return i;
		i += 1;
		}
	}

