
#include "../melee.h"
#include "mmain.h"
#include "manim.h"

Animation::Animation(double ox, double oy, SpaceSprite *osprite,
  int ofcount, int ofsize, int olayer) :
  SpaceObject(ox, oy, 0.0, -1, osprite),
  frame_count(ofcount),
  frame_size(ofsize),
  frame_step(ofsize)
{
	layer = olayer;
	collide_flag_anyone = 0;
	mass = 0;
}

void Animation::calculate() {
	frame_step -= frame_time;
	while (frame_step < 0) {
		frame_step += frame_size;
		sprite_index++;
		if(sprite_index == frame_count) state = 0;
		}
	SpaceObject::calculate();
	}

FixedAnimation::FixedAnimation(SpaceLocation *opos, SpaceSprite *osprite,
  int ofcount, int ofsize, int olayer) :
  Animation(0.0, 0.0, osprite, ofcount, ofsize, olayer),
  pos(opos)
{
  if(pos->exists()) {
    x = pos->normal_x();
    y = pos->normal_y();
  } else
    state = 0;
}

void FixedAnimation::calculate()
{
  if(pos->exists()) {
    x = pos->normal_x();
    y = pos->normal_y();
    Animation::calculate();
  } else
    state = 0;
}
