
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <allegro.h>

#include "../melee.h"
#include "../libs.h"
#include "../scp.h"
#include "../frame.h"
#include "../ais.h"

#include "mmain.h"
#include "mview.h"
#include "mcontrol.h"
#include "mcbodies.h"
#include "mshppan.h"
#include "mship.h"

// Define global space frame
SpaceFrame *spaceFrame = NULL;
// Define global planet object
Planet *spacePlanet = NULL;



#define MSECS_PER_TIC								5
#define MSECS_PER_FPS								100
int frame_time;
static int maximum_msecs_per_render;
static int msecs_per_physics;
int time_ratio; //1000 milliseconds / SC2 framerate
double distance_ratio;
int scale_frames(double value) {
	return (int)((value + 1) * time_ratio);
	}
double scale_turning (double turn_rate) {
//  turn_rate = 20.0 / ((turn_rate + 1.0) * 5.0);	
	return (360. / 16) / (turn_rate + 1.0) / time_ratio;
	}
double scale_velocity (double velocity) {
//  velocity = velocity / 7.5;
//velocity = x sc2pixels / sc2frame
//velocity = y twpixels / twframe
//velocity = x (1. / 1600) / (50ms)
//velocity = y (1. / 3840) / (1ms)
// y = x * (3840 / 1600) / 50
// WTF????
	return velocity * distance_ratio / time_ratio;
	}
double scale_acceleration (double acceleration, double raw_hotspot_rate) {
//  accel_rate = accel_rate / 100.0;
	return acceleration * distance_ratio / (1 + raw_hotspot_rate) / time_ratio / time_ratio; 
	}
double scale_range (double range) {
	return range * 40;
	}

#define time_buf_len 4
volatile int total_physics[time_buf_len];
volatile int total_renders[time_buf_len];
volatile int timed_physics[time_buf_len];
volatile int timed_renders[time_buf_len];
volatile int timing_pos = 0;

int game_time;
int play_mode;
int hero;
int first_local_player;
int num_local_players;
int num_players;
char      **name = NULL;
Control   **control = NULL;
ShipPanel **panel = NULL;

Frame *space;
Frame *radar;

SHIP_INFO ship_info[MAX_SHIP_TYPES];
char     *ship_name[MAX_SHIP_TYPES + 1];
int       num_ship_types;

char *fleet_id[MAX_FLEET_SIZE];
char *fleet_name[MAX_FLEET_SIZE];

char fleet_title[80];
int  fleet_size = 0;
int  fleet_cost = 0;

char *debug_string = NULL;
int debug_value = 0;

char strEmptySlotID[] = "?????";
char strEmptySlotName[] = "[Empty slot]";

DATAFILE *melee = NULL;
DATAFILE *scppal = NULL;

int melee_paused = 0;

static volatile int melee_time;

void melee_timer() {
	if (!melee_paused) melee_time += MSECS_PER_TIC;
	}
END_OF_FUNCTION(melee_timer);

void fps_proc() {
	timing_pos += 1;
	if (timing_pos == time_buf_len) timing_pos = 0;
	total_physics[timing_pos] = 0;
	total_renders[timing_pos] = 0;
	timed_physics[timing_pos] = 0;
	timed_renders[timing_pos] = 0;
	}
END_OF_FUNCTION(fps_proc);

char *selectListboxGetter(int index, int *list_size);


DIALOG help_dialog[] =
{
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)     (d1)  (d2)  (dp)
  { d_box_proc,        80,  50,    480,  400,  255,  0,    0,    0,          0,    0,    NULL, NULL, NULL },
  { d_button_proc,     85,  55,    470,  30,   255,  0,    0,    D_EXIT,     0,    0,    (void *)"Exit help screen" , NULL, NULL },
  { d_textbox_proc,    85,  90,    470,  355,  255,  0,    0,    0,          0,    0,    NULL, NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,          0,    0,    NULL, NULL, NULL }
};

void show_help() {
	int i;
	char buffy[100000];
	suspend_melee();
	PACKFILE *f;
	f = pack_fopen ("readme.txt", F_READ);
	if (!f) strcpy(buffy, "Failed to load readme.txt");
	else {
		i = pack_fread (buffy, 99999, f);
		pack_fclose(f);
		buffy[i] = 0;
		}
	set_dialog_color(help_dialog, pallete_color[0], pallete_color[15]);
	help_dialog[2].dp = (void *) buffy;
	popup_dialog(help_dialog, 1);
	resume_melee();
	return;
	}

int melee_done;

void       load_ship_data(int index);
void       free_ships(int ship1, int ship2);
ShipPanel *select_ship(int player, int index);
int        ship_idtoindex(const char *id_str);

void suspend_melee();
void resume_melee();
void save_screen_shot();


int *total_fleet;
int *slot;
int *ship;
int show_fps = 0;
int antia_on;



static int log_num = 0;
static int log_size[256];
static int log_len[256];
static int log_pos[256];
static char *log_data[256];

void tw_log_start() {
	for (int i = 0; i < 256; i += 1) {
		log_len[i] = 0;
		log_pos[i] = 0;
		log_size[i] = 0;
		log_data[i] = NULL;
		}
	log_num = 0;
	return;
	}
void tw_log_end() {
	for (int i = 0; i < 256; i += 1) {
		free(log_data[i]);
		log_len[i] = 0;
		log_size[i] = 0;
		log_data[i] = NULL;
		}
	return;
	}
void tw_log_save (char *fname) {
	PACKFILE *f;
	f = pack_fopen ( "demo.log", F_WRITE_PACKED);
	if (!f) tw_error ("tw_log_save - failed to open demo.log");
	pack_iputl ( log_num, f);
	for (int i = 0; i < 256; i += 1) if (log_len[i]) {
		f = pack_fopen_chunk(f, 0);
		pack_iputl ( i, f);
		pack_iputl ( log_len[i], f);
		pack_fwrite ( log_data[i], log_len[i], f);
		f = pack_fclose_chunk(f);
		}
	pack_fclose (f);
	return;
	}
void tw_log_load (char *fname) {
	PACKFILE *f;
	int i;
	f = pack_fopen ( "demo.log", F_READ_PACKED);
	if (log_num) tw_error ("tw_log_load - logs already exist");
	if (!f) tw_error ("tw_log_load - failed to open demo.log");
	log_num = pack_igetl ( f);
	for (int j = 0; j < log_num; j += 1) {
		f = pack_fopen_chunk(f, 0);
		i = pack_igetl ( f);
		log_len[i] = pack_igetl ( f);
		log_size[i] = log_len[i];
		log_data[i] = (char *) malloc(log_size[i]);
		pack_fread ( log_data[i], log_len[i], f);
		f = pack_fclose_chunk(f);
		}
	pack_fclose (f);
	return;
	}

int tw_log_ready(int id) {
	return log_len[id] - log_pos[id];
	}
void tw_log(int id, void *data, int size) {
	if (play_mode == MELEE_PLAYBACK) return;
	log_len[id] += size;
	while (log_len[id] > log_size[id]) {
		if (log_size[id] == 0) log_num += 1;
		if (log_size[id]) log_size[id] = log_size[id] * 2;
		else log_size[id] = 16;
		log_data[id] = (char *) realloc(log_data[id], log_size[id]);
		}
	memmove(log_data[id]+(log_len[id]-size), data, size);
	return;
	}
void tw_unlog(int id, void *data, int size) {
	if (tw_log_ready(id) < size) {
		melee_done = TRUE;
		return;
		}
	memmove(data, log_data[id] + log_pos[id], size);
	log_pos[id] += size;
	return;
	}
int tw_log_file_ready(char *name){
	int i = 0, j = 0;
	while (i < log_len[255]) {
		if (strcmp((char*) log_data[255] + i, name)) {
			i += strlen((char*) log_data[255] + i) + 1;
			j += *((int*)(log_data[255] + i));
			i += 4;
			}
		else {
			i += strlen((char*) log_data[255] + i) + 1;
			int k = *((int*)(log_data[255] + i));
			return k;
			}
		}
	return 0;
	}
void tw_log_file(char *name){
	char buffy[1024];
	PACKFILE *f;
	int i, j = 0;
	tw_log (255, name, strlen(name)+1);
	f = pack_fopen(name, F_READ);
	if (!f) {
		sprintf(buffy, "tw_log_file - bad file name %s", name);
		tw_error (buffy);
		}
	do {
		i = pack_fread(buffy, 1024, f);
		tw_log(254, buffy, i);
		j += i;
		} while (i > 0);
	tw_log(255, &j, 4);
	}
void tw_unlog_file(char *name) {
	int i = 0, j = 0;
	while (i < log_len[255]) {
		if (strcmp((char*) log_data[255] + i, name)) {
			i += strlen((char*) log_data[255] + i) + 1;
			j += *((int*)(log_data[255] + i));
			i += 4;
			}
		else {
			i += strlen((char*) log_data[255] + i) + 1;
			int k = *((int*)(log_data[255] + i));
			set_config_data(log_data[254] + j, k);
			return;
			}
		}
	char buffy[256];
	sprintf(buffy, "tw_log_file - bad file name %s", name);
	tw_error (buffy);
	set_config_file (name);
	}



int gamestate_checksum = 0;
int desynched_frame = -1;

void calculate_gamestate_checksum() {
	int i;
	double g = 0;
	SpaceLocation *f;
	for (i = 0; i < SPACE_LAYERS; i += 1) {
		f = spaceFrame->getFirstObject (i);
		while (f) {
			g += f->normal_x ();
			f = f->next;
			}
		}
	gamestate_checksum = (int(g * 256) + random()) & 255;
	return;
	}


void choose_new_ships() {
	int i;
	if (melee_done) return;
	for (i = 0; i < num_players; i += 1) if ((!panel[i] || !panel[i]->ship) && (slot[i] != -1)) {
		if (panel[i]) delete panel[i];
		panel[i] = NULL;
		char tmp[40];
		sprintf (tmp, "Fleet%d", i+1);
		load_fleet("fleet.tmp", tmp);
		clear_fleet_slot(slot[i]);
		save_fleet("fleet.tmp", tmp);
		load_fleet("fleet.tmp", tmp);
		if (fleet_size != 0) {
			slot[i] = control[i]->choose_ship(i, total_fleet[i]);
			tw_log(LOG_PLAYER_SHIPS + i, &slot[i], 1);
			tw_unlog(LOG_PLAYER_SHIPS + i, &slot[i], 1);
			if (slot[i] == 127) slot[i] = random() % fleet_size;
			ship[i] = ship_idtoindex(fleet_id[slot[i]]);
			panel[i] = select_ship(i, ship_idtoindex(fleet_id[slot[i]]));
			panel[i]->ship->locate();
			spaceFrame->addSpaceObject(panel[i]->ship);
			}
		else {
			slot[i] = -1;
			char tmp[80];
			sprintf(tmp, "%s has no ships remaining", name[i]);
			if(alert(tmp, NULL, NULL, "&Abort game", "&Resume playing", 'a', 'r') == 1)
				melee_done = TRUE;
			}
		if (panel[i] && panel[i]->ship) {
			control[i]->select_ship(panel[i]->ship, ship_info[ship[i]].reg->id);
			for (int t = 0; t < num_players; t += 1) {
				if (t != i) {
					if (panel[t] && panel[t]->ship) control[i]->add_target(panel[t]->ship);
					control[t]->add_target(panel[i]->ship);
					}
				}
			}
		}
	return;
	}

void play_frame() {
  int of = melee_time;
	int i;

  poll_keyboard();
  if (of < msecs_per_physics) return;

	for (i = 0; i < num_players; i += 1) {
    control[i]->calculate();
		if (control[i]->ship) {
			tw_log   (LOG_PLAYER_KEYS, &(control[i]->ship->nextkeys), 1);
			tw_unlog (LOG_PLAYER_KEYS, &(control[i]->ship->nextkeys), 1);
			}
		poll_keyboard();
		if (key[KEY_F9] && control[i]->ship) {
			control[i]->ship->translate((random()%3)-50, (random()%3)-1);
			}
		}


  spaceFrame->calculate();
  spaceFrame->collide();

	for (i = 0; i < num_players; i += 1) {
    if (panel[i]) panel[i]->calculate();
		}

	view->calculate();
	calculate_gamestate_checksum();
	i = gamestate_checksum & 0xff;
	tw_log   ( LOG_CHECKSUM, &i, 1);
	tw_unlog ( LOG_CHECKSUM, &i, 1);
	if ((i != (gamestate_checksum & 0xff)) && (i != 255)) {
		if (desynched_frame == -1) desynched_frame = game_time;
		palette_color[0] = random();
		}

  timed_physics[timing_pos] += melee_time - of;
  total_physics[timing_pos] += 1;
  melee_time -= msecs_per_physics;
  game_time += frame_time;
	if (key[KEY_F4] && (melee_time < maximum_msecs_per_render)) melee_time += msecs_per_physics * 4 / 5;
	return;
	}

void animate_frame () {
	int of = melee_time;
	if (keypressed()) {
		int k = readkey() >> 8;
		switch (k) {
			case KEY_ESC:
			case KEY_F10:
				suspend_melee();
				font = desktop_font;
				if(alert("Game is paused", NULL, NULL, "&Abort game", "&Resume playing", 'a', 'r') == 1)
					melee_done = TRUE;
				font = (FONT *)(scppal[SCPPAL_FONT].dat);
				resume_melee();
				break;
			case KEY_F1: // help
				show_help();
				break;
			case KEY_F3: // switch hero
				hero += 1;
				if (hero >= first_local_player + num_local_players) hero = first_local_player;
				break;
			case KEY_F5: // view fleets
				break;
			case KEY_F2: // options
				suspend_melee();
				font = (FONT *)(scppal[SCPPAL_FONT].dat);
				destroy_bitmap (space->child); space->child = NULL;
				destroy_bitmap (space->frame); space->frame = NULL;
				destroy_bitmap (radar->child); radar->child = NULL;
				change_options();
				view_x = screen_x - PANEL_WIDTH * (int)ceil(num_players / (double) PANELS_PER_COLUMN);
				view_y = screen_y;
				space->frame = create_bitmap (view_x, view_y);
				space->child = create_sub_bitmap (screen, 0, 0, view_x, view_y);
				radar->child = create_sub_bitmap (screen, screen_x-60, screen_y-52, 56, 48);
				font = (FONT *)(scppal[SCPPAL_FONT].dat);
				resume_melee();
				break;
			case KEY_F12:
				show_fps = !show_fps;
				break;
			case KEY_F11:
				suspend_melee();
				save_screen_shot();
				resume_melee();
				break;
			}
		}
	if (!debug_string) debug_string = (char *) malloc(8000);
  if(show_fps) {
		char *s = debug_string;
    int a, b, c, d;
    a = b = 0;
    c = d = 1;
    for (int i = 0; i < time_buf_len; i += 1) if (i != timing_pos) {
      a += timed_physics[i];
      b += timed_renders[i];
      c += total_physics[i];
      d += total_renders[i];
      }
    s += sprintf(s, "   physics: %.1f ms  \n", double(a) / c);
    s += sprintf(s, "   renders: %.1f ms  \n", double(b) / d);
    s += sprintf(s, "   debug: %d  \n", debug_value);
    s += sprintf(s, "   Frames Per Second: %d  \n", (d-1) * 1000 / MSECS_PER_FPS / time_buf_len);
    s += sprintf(s, "   %d  %d  %d  %d  \n", game_time, frame_time, msecs_per_physics, melee_time);
		}
	else {
		debug_string[0] = '\0';
		}
	view->animate();
	timed_renders[timing_pos] += (melee_time - of);
	total_renders[timing_pos] += 1;
	return;
	}

int melee_state = -1;
void melee_init ( int _play_mode) {
	int i, j, k;
	char tmp[80];
	const char *t;
  LOCK_FUNCTION(melee_timer);
  LOCK_VARIABLE(melee_time);
  LOCK_VARIABLE(melee_paused);

  LOCK_FUNCTION(fps_proc);
  LOCK_VARIABLE(total_physics);
  LOCK_VARIABLE(total_renders);
  LOCK_VARIABLE(timed_physics);
  LOCK_VARIABLE(timed_renders);
  LOCK_VARIABLE(timing_pos);

	play_mode = _play_mode;
	gamestate_checksum = 0;
	desynched_frame = -1;
  melee_done = FALSE;
  game_time = 0;
	melee_time = 0;
  for (i = 0; i < time_buf_len; i += 1) {
    total_physics[i] = 0;
    total_renders[i] = 0;
    timed_physics[i] = 0;
    timed_renders[i] = 0;
    }
  melee = load_datafile("melee.dat");
  if(!melee) tw_error("Error loading melee data\n");
	PANELS_PER_COLUMN = (screen_y - 80) / PANEL_HEIGHT;
	
  asteroidSprite          = new SpaceSprite(&melee[MELEE_ASTEROID], ASTEROID_FRAMES);
  asteroidExplosionSprite = new SpaceSprite(&melee[MELEE_ASTEROIDEXPLOSION], ASTEROIDEXPLOSION_FRAMES);
  hotspotSprite           = new SpaceSprite(&melee[MELEE_HOTSPOT], HOTSPOT_FRAMES);
  kaboomSprite            = new SpaceSprite(&melee[MELEE_KABOOM], KABOOM_FRAMES);
  sparkSprite             = new SpaceSprite(&melee[MELEE_SPARK], SPARK_FRAMES);

  gui_bg_color = pallete_color[0];
  gui_fg_color = pallete_color[15];
  text_mode(-1);

  font = (FONT *)(scppal[SCPPAL_FONT].dat);

	tw_log_start();
	if (play_mode == MELEE_PLAYBACK) tw_log_load ("demo.log");

	tw_log_file("scp.ini");
	tw_unlog_file("scp.ini");
	i = 0;
	num_players = 0;
	while (true) {
		sprintf (tmp, "Player%d", i+1);
		t = get_config_string (tmp, "Type", NULL);
		if (!t) break;
		if (strcmp(t, "None")) num_players += 1;
		i += 1;
		}
	num_local_players = num_players;
	first_local_player = 0;
	hero = first_local_player;
	i = time(NULL);
	tw_log   (LOG_MAIN, &i, 4);
	tw_unlog (LOG_MAIN, &i, 4);
	srandom(i);	

  switch (play_mode) {
		case MELEE_NORMAL:
		case MELEE_RECORD:
		case MELEE_PLAYBACK:
			if (!num_players) return;
			control = new Control*[num_players];
			name    = new char*[num_players];
			i = j = 0;
			while (true) {
				sprintf (tmp, "Player%d", i+1);
				t = get_config_string (tmp, "Type", NULL);
				if (!t) {
					if (j != num_local_players) tw_error ("melee_init: What The Fuck?");
					else break;
					}
				k = get_config_int (tmp, "Config", 0);
				if (strcmp(t, "None")) {
					name[first_local_player + j] = strdup(tmp);
					sprintf (tmp, "%s(%s%d)", tmp, t, get_config_int(name[first_local_player + j], "Config", 0));
					control[first_local_player + j] = getController(control2number(t), tmp, first_local_player + j);
					sprintf (tmp, "Config%d", k);
					control[first_local_player + j]->load("scp.ini", tmp);
					tw_unlog_file("scp.ini");
					j += 1;
					}
				i += 1;
				}
			total_fleet = new int[num_players];
			slot = new int[num_players];
			ship = new int[num_players];
			delete_file("fleet.tmp");
			for (i = 0; i < num_players; i += 1) {
				load_fleet("fleets.ini", name[i]);
				sprintf (tmp, "Fleet%d", i+1);
				save_fleet("fleet.tmp", tmp);
				total_fleet[i] = fleet_cost;
				slot[i] = -2;
				ship[i] = -1;
				}
			break;
		default:
			tw_error (" That mode of play is not yet supported.");
			break;
		}

	if (play_mode == MELEE_PLAYBACK) {
		for (i = 0; i < num_players; i += 1) {
			delete control[i];
			control[i] = new ControlVegetable(name[i], i);
			}
		}
	if ((play_mode == MELEE_NET1_SERVER) || (play_mode == MELEE_NET1_SERVER)) {
		for (i = 0; i < num_players; i += 1) {
			if ((i - first_local_player < 0) || (i - first_local_player >= num_local_players)) {
				delete control[i];
				control[i] = new ControlVegetable(name[i], i);
				}
			}
		}

//use remote .ini file
  tw_unlog_file("scp.ini");
	time_ratio = (int)(1000. / get_config_float ("SCP", "SC2FrameRate", 20));
	distance_ratio = (3840. / get_config_float ("SCP", "SC2TotalDistance", 8000));
	frame_time = (int)(1000. / get_config_float ("SCP", "FrameRate", 40) + 0.5);
	msecs_per_physics = (int)(frame_time / get_config_float("SCP", "Turbo", 1) + 0.5);
	maximum_msecs_per_render = 
			(int)(1000. / get_config_float("SCP", "MinimumFrameRate", 10) + 0.5);

	int planet_num = random() % 3;
//  set_pallete((RGB*)(scppal[planet_num + 1].dat));

	panel = new ShipPanel*[num_players];
	for (i = 0; i < num_players; i += 1) {
		control[i]->initialize();
		panel[i] = NULL;
		}

	view_x = screen_x - PANEL_WIDTH * (int)ceil(num_players / (double) PANELS_PER_COLUMN);
	view_y = screen_y;
  space = new Frame(0, 0, view_x, view_y, MAX_SPACE_ITEMS);
  radar = new Frame(screen_x - 60, screen_y - 52, 56, 48, MAX_RADAR_ITEMS);
	view->init();

  spaceFrame = new SpaceFrame(space, radar, SPACE_LAYERS);
  spacePlanet = new Planet(new SpaceSprite(&melee[MELEE_PLANET + planet_num], 1));
  spaceFrame->addSpaceObject(spacePlanet);
	for (i = 0; i < NUM_ASTEROIDS; i += 1) spaceFrame->addSpaceObject(new Asteroid());

	set_volumes();
  draw_rle_sprite(screen, (RLE_SPRITE *)(melee[MELEE_PANEL].dat), SCREEN_W - 64, SCREEN_H - 80);

	suspend_melee();
	install_int(melee_timer, MSECS_PER_TIC);
	install_int(fps_proc, MSECS_PER_FPS);

	melee_state = 0;
	return;
	}

void melee_end() {
	int i;
	remove_int(melee_timer);
	remove_int(fps_proc);
	resume_melee();
	tw_log   (LOG_MAIN, &game_time, 4);
	tw_unlog (LOG_MAIN, &game_time, 4);
	if (play_mode == MELEE_RECORD) tw_log_save ("demo.log");
	tw_log_end();
  switch (play_mode) {
		case 0:
		case 1:
			for (i = 0; i < num_players; i += 1) {
				control[i]->deinitialize();
				delete control[i];
				control[i] = NULL;
				delete name[i];
				name[i] = NULL;
				if (panel[i] != NULL) delete panel[i];
				}
			delete control;
			delete name;
			break;
		default:
			break;
		}

	view->deinit();

  delete asteroidSprite;					asteroidSprite = NULL;
  delete asteroidExplosionSprite;	asteroidExplosionSprite = NULL;
  delete hotspotSprite;						hotspotSprite = NULL;
  delete kaboomSprite;						kaboomSprite = NULL;
  delete sparkSprite;							sparkSprite = NULL;

  delete spaceFrame;							spaceFrame = NULL;
	spacePlanet = NULL;

  delete radar;										radar = NULL;
  delete space;										space = NULL;

	delete_file("fleet.tmp");
  free_ships(-1, -1);
  clear(screen);
  unload_datafile(melee); melee = NULL;
	set_volumes();

	melee_state = -1;
	return;
	}

void play_melee( int _play_mode) {
	melee_init(_play_mode);
	if (melee_state < 0) return;
	choose_new_ships();
	play_mod((JGMOD *)(melee[MELEE_MUSIC].dat), TRUE);
	meleeVictory = NULL;
	int last_draw_time = game_time;
	int victory_time = 0;
  resume_melee();
	while(!melee_done) {
		if (!victory_time) {
			for (int i = 0; i < num_players; i += 1) {
				if (!panel[i] || !panel[i]->exists()) {
					if (meleeVictory) play_mod(meleeVictory, FALSE);
					meleeVictory = NULL;
					victory_time = game_time + 3000;
					}
				}
			}
		else if (game_time >= victory_time) {
			suspend_melee();
			victory_time = 0;
			choose_new_ships();
//    free_ships(ship1, ship2);
			resume_melee();
			}
		if(!is_mod_playing()) {
			play_mod((JGMOD *)(melee[MELEE_MUSIC].dat), TRUE);
			meleeVictory = NULL;
			}
		play_frame();
		if (key[KEY_ESC] || (game_time > last_draw_time + maximum_msecs_per_render) ||
				(melee_time < msecs_per_physics)) {
			animate_frame();
			last_draw_time = game_time;
			}
		}
	suspend_melee();
	stop_mod();
	if(meleeVictory)
		play_mod(meleeVictory, FALSE);
	melee_end();
	return;
	}

void suspend_melee()
{
  gui_bg_color = pallete_color[15];
  gui_fg_color = pallete_color[0];
  melee_paused += 1;
}

void resume_melee() {
	int i;
	if (spaceFrame) {
		text_mode(-1);
		clear_to_color(screen, pallete_color[0]);
		rectfill (screen, view_x, 0, screen_x-1, screen_y-1, pallete_color[8]);
		if (space) space->add_box(0, 0, view_x, view_y);
		if (radar) radar->add_box(0, 0, 56, 48);
		for (i = 0; i < num_players; i += 1) {
			if (panel && (panel[i]) && (panel[i]->exists())) panel[i]->refresh(i);
			}
		if (melee) draw_rle_sprite(screen, (RLE_SPRITE *)(melee[MELEE_PANEL].dat),
				SCREEN_W - 64, SCREEN_H - 80);
		}
	melee_paused -= 1;
	return;
	}

void save_screen_shot()
{
  static int shot_index = 0;

  BITMAP *bmp;
  PALLETE pal;

  char path[80];

  get_pallete(pal);
  bmp = create_bitmap(SCREEN_W, SCREEN_H);
  acquire_screen();
  blit(screen, bmp, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
  release_screen();

  if(shot_index < 10000) {
    sprintf(path, "scrshots/shot%04d.pcx", shot_index);
    while(exists(path)) {
      shot_index++;
      sprintf(path, "scrshots/shot%04d.pcx", shot_index);
    }
  } else
    sprintf(path, "scrshots/");

  font = desktop_font;
  if(file_select("Save screen shot", path, "BMP;PCX;TGA"))
    save_bitmap(path, bmp, pal);

  destroy_bitmap(bmp);
  font = (FONT *)(scppal[SCPPAL_FONT].dat);
}
/*

#define VICTORY_DIALOG_TITLE     0
#define VICTORY_DIALOG_LIST      1
#define VICTORY_DIALOG_PLAYERBOX 2
#define VICTORY_DIALOG_PLAYER    3
#define VICTORY_DIALOG_CONTINUE  4

void show_fleet(int player, char *fleet_file, int fleet_total, int slot)
{
  load_fleet(fleet_file, "Fleet");

  sprintf(selectPlayer, "Player %d Fleet", player+1);

  sprintf(selectTitleString, "%s\n%d of %d points", fleet_title, fleet_cost, fleet_total);
  victoryDialog[VICTORY_DIALOG_LIST].d1 = slot;
  do_dialog(victoryDialog, VICTORY_DIALOG_CONTINUE);
}*/

void register_ship(SHIP_REGISTER_INFO *reg_info)
{
  if(num_ship_types >= MAX_SHIP_TYPES)
    return;

  char fn[28];

  fn[0] = '\0';
  strcat(fn, "ships/shp");
  strcat(fn, reg_info->id);
  strcat(fn, ".dat");

  if(!exists(fn))
    return;

  ship_info[num_ship_types].reg = reg_info;
  ship_info[num_ship_types].dat = NULL;

  strcat(fn, "#SHIP_DAT");
  ship_info[num_ship_types].cost = get_config_int("Ship", "Cost", 0);

  num_ship_types++;
}

char shipSelection[80];
char *shipListboxGetter(int index, int *list_size)
{
  if(index < 0) {
    *list_size = num_ship_types;
    return NULL;
  } else {
    sprintf(shipSelection, "%s %d", ship_name[index], ship_info[index].cost);
    return shipSelection;
  }
}

void init_fleet()
{
  int i;

  for(i = 0; i < MAX_FLEET_SIZE; i++) {
    fleet_id[i] = strEmptySlotID;
    fleet_name[i] = strEmptySlotName;
  }

  fleet_size = 0;
  fleet_cost = 0;
  sprintf(fleet_title, "Untitled");
}

void select_fleet_slot(int slot, int ship_index)
{
	if (slot < 0) return;
  if(fleet_id[slot] == strEmptySlotID)
    fleet_size++;
  else
    fleet_cost -= ship_info[ship_idtoindex(fleet_id[slot])].cost;

  fleet_cost += ship_info[ship_index].cost;

  fleet_id[slot] = ship_info[ship_index].reg->id;
  fleet_name[slot] = ship_info[ship_index].reg->name;
}

void clear_fleet_slot(int slot)
{
	if (slot < 0) return;
  if(fleet_id[slot] == strEmptySlotID)
    return;

  fleet_cost -= ship_info[ship_idtoindex(fleet_id[slot])].cost;
  fleet_id[slot] = strEmptySlotID;
  fleet_name[slot] = strEmptySlotName;
  fleet_size--;
}

void save_fleet(char *filename, char *section)
{
  int i, count = 0;
  char slot_str[8];

  if (filename) set_config_file(filename);

  for(i = 0; i < MAX_FLEET_SIZE; i++) {
    if(strcmp(fleet_id[i], strEmptySlotID) != 0) {
      sprintf(slot_str, "Slot%d", count);
      set_config_string(section, slot_str, fleet_id[i]);
      count++;
    }
  }

  for(i = count; i < MAX_FLEET_SIZE; i++) {
    sprintf(slot_str, "Slot%d", i);
    set_config_string(section, slot_str, NULL);
  }

  set_config_int(section, "Size", count);
  set_config_string(section, "Title", fleet_title);

  // to force saved SCF files to be written
  set_config_file("scp.ini");
}

int ship_idtoindex(const char *id_str)
{
  int i = 0, found = FALSE;

  #ifdef SCP_DEBUG
  fprintf(debug_file, "- ShipID to index %s\n", id_str);
  fflush(debug_file);
  #endif

  if(id_str == NULL) return -1;

  while((i < num_ship_types) && (!found)) {
    if(strcmp(id_str, ship_info[i].reg->id) == 0)
      found = TRUE;
    else
      i++;
  }

  if(found)
     return(i);
  else
    return(-1);
}

void load_fleet(char *filename, char *section)
{
  int i, count, ship_index;
  char slot_str[8];
  const char *slot_id, *title;

  init_fleet();

  if (filename) set_config_file(filename);
  count = get_config_int(section, "Size", 0);
  title = get_config_string(section, "Title", "");
  sprintf(fleet_title, title);

  for(i = 0; i < count; i++) {
    sprintf(slot_str, "Slot%d", i);
    slot_id = get_config_string(section, slot_str, "?????");
    ship_index = ship_idtoindex(slot_id);
    if(ship_index >= 0)
      select_fleet_slot(i, ship_index);
  }

  fleet_size = count;
}

char *fleetListboxGetter(int index, int *list_size)
{
  if(index < 0) {
    *list_size = MAX_FLEET_SIZE;
    return NULL;
  } else
    return fleet_name[index];
}

void load_ship_data(int index)
{
  if(ship_info[index].dat != NULL)
    return;

  char fn[19];

  fn[0] = '\0';
  strcat(fn, "ships/shp");
  strcat(fn, ship_info[index].reg->id);
  strcat(fn, ".dat");

  ship_info[index].dat = new ShipData(fn);
}

void init_ships()
{
  int i;

  num_ship_types = 0;

  #include "../ships.h"

  if(num_ship_types == 0) tw_error("No ship data available.\n");

  for(i = 0; i < num_ship_types; i++)
    ship_name[i] = ship_info[i].reg->name;
}

void free_ships(int ship1, int ship2) {
	int i;

	for(i = 0; i < num_ship_types; i++) {
		if((ship_info[i].dat != NULL) && (i != ship1) && (i != ship2)) {
			delete ship_info[i].dat;
			ship_info[i].dat = NULL;
			}
		}
	}

ShipPanel *select_ship(int player, int index) {
	int    radar_color = RADAR_COLOR_FRIEND;
	double angle, x, y;

	if(player != hero) radar_color = RADAR_COLOR_ENEMY;

	x = (double)(random() % (long)(X_MAX));
	y = (double)(random() % (long)(Y_MAX));
	angle = (double)(random() % 64) * 5.625;

	load_ship_data(index);

	char buffy[64];
	buffy[0] = 0;
	strcat (buffy, "ships/");
	strcat (buffy, ship_info[index].reg->id);
	strcat (buffy, ".ini");
	tw_log_file(buffy);
	tw_unlog_file(buffy);
  
	return(new ShipPanel(
			ship_info[index].reg->getShip(x, y, angle, player, radar_color,
			ship_info[index].dat, control[player]), player));
	}

int tw_sample (SAMPLE *spl, int vol, int pan, int freq) {
	if (sound_on) 
			return play_sample (spl, (vol * sound_volume) >> 8, pan, freq, false);
	else return 0;
	}
