
#ifndef _MMAIN_H
#define _MMAIN_H

extern char *debug_string;
extern int debug_value;
extern int game_time;
extern int frame_time;

extern int hero;
extern int num_players;
extern int num_local_players;
extern int first_local_player;
extern Control **control;
extern ShipPanel **panel;

extern Frame *space;
extern Frame *radar;

extern DATAFILE *melee;
extern DATAFILE *scppal;

extern Planet *spacePlanet;

extern int antia_on;

extern char fleet_title[];
extern int  fleet_cost;
extern int  fleet_size;
extern char *fleet_id[MAX_FLEET_SIZE];
extern char *fleet_name[MAX_FLEET_SIZE];

void init_fleet();
void select_fleet_slot(int slot, int ship_index);
void clear_fleet_slot(int slot);
void save_fleet(char *filename, char *section);
void load_fleet(char *filename, char *section);

#define MELEE_NORMAL      0
#define MELEE_RECORD      1
#define MELEE_PLAYBACK    2
#define MELEE_NET1_SERVER 3
#define MELEE_NET1_CLIENT 4
void play_melee( int play_mode);

void resume_melee();
void suspend_melee();

void show_help() ;

#define LOG_MAIN            0 //random number seed, game type, total frames
#define LOG_CHECKSUM        1 //checksums for each frame
#define LOG_PLAYER_KEYS    64 //player keypresses for each frame
#define LOG_PLAYER_SHIPS  128 //player ship selections
void tw_log_start() ;
void tw_log_end() ;
void tw_log_save (char *fname) ;
void tw_log_load (char *fname) ;

int tw_log_ready (int id);
void tw_log(int id, void *data, int size) ;
void tw_unlog(int id, void *data, int size) ;
int tw_log_file_ready(char *name);
void tw_log_file(char *name);
void tw_unlog_file(char *name);

#endif