#include <string.h>

#include "../melee.h"

#define   NO_JGMOD
#define   NO_AASTR
#include "../libs.h"

#include "mnet.h"

#if defined NETWORK_BSD

#include <unistd.h>
#include <dos.h>
#include <lsck/lsck.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <arpa/nameser.h>
#include <fcntl.h>
#include <errno.h>

#define SOCKET int
#define INVALID_SOCKET -1
#define get_error() errno
#define set_error(a) (errno = a)
#define close_socket(a) close(a)
#define SOCKET_ERROR -1

#elif defined NETWORK_WINSOCK

#include <winalleg.h>
#include "winsock.h"
#define get_error() WSAGetLastError()
#define set_error(a) WSASetLastError(a)
#define close_socket(a) closesocket(a)

#endif

#ifndef NETWORK_NONE

static int network_status = 0;
#define NETWORK_STATUS_WINSOCK_STARTED 0x01

static void msg (char *) {}

static void (*essage)(char *txt);

int NetTCP::num_connections = 0;
int *NetTCP::open_sockets = 0;
void (* NetTCP::message)(char*) = &msg;

//int *open_sockets;
//int num_connections;
//void (*msg)(char *txt);
int NetTCP::init() {
	open_sockets = NULL;
	num_connections = 0;
	message = &msg;
#if defined NETWORK_WINSOCK
	if (! (network_status & NETWORK_STATUS_WINSOCK_STARTED)) {
		WSADATA info;
		if (WSAStartup (MAKEWORD(1,1), &info) != 0) {
			message("winsock startup failed");
			return -1;
			}
		message ("winsock started");
		network_status |= NETWORK_STATUS_WINSOCK_STARTED;
		}
	else message ("winsock already started");
#elif defined NETWORK_BSD
#endif
	return 0;
	}

void NetTCP::deinit() {
	for (int i = 0; i < num_connections; i += 1) {
		int t = open_sockets[i];
		if (t != INVALID_SOCKET) close(open_sockets[i]);
		}
	free (open_sockets);
	open_sockets = NULL;
	num_connections = 0;
	}

int NetTCP::listen(int port, int (*callback)(NetTCP *)) {
/*	sock = socket( AF_INET, SOCK_STREAM, 0);
	if (sock == INVALID_SOCKET) {
		message("socket allocation failed\n");
		return -1;
		}
	message ("socket allocated");
	net_ip4 _self;
	sockaddr_in *self = (sockaddr_in *) &_self;
	self->sin_family = AF_INET;
	self->sin_port = htons(port);
	self->sin_addr.s_addr = 0;
	memset(&(self->sin_zero), 0, 8);
	if (port) {
		char tmp[80];
		if (bind (sock, (sockaddr *) self, sizeof(sockaddr_in) ) == INVALID_SOCKET) {
// is that right for error values? under BSD & winsock?
			sprintf (tmp, "bind to port %d failed\n", port);
			message (tmp);
			return -3;
			}
		else {
			char tmp[80];
			sprintf (tmp, "socket bound to port", port);
			message (tmp);
			}
		}
	else message ("no port binding requested");
	return port;*/
	return 0;
	}
int NetTCP::connect(void *address, int port) {
	return 0;
	}
int NetTCP::disconnect(void *address, int port) {
	return 0;
	}
int NetTCP::read2send() {
	return 0;
	}
int NetTCP::read2recv() {
	return 0;
	}
int NetTCP::send(int who, int size, void *data) {
	return 0;
	}
int NetTCP::recv(int who, int min, int max, void *data) {
	return 0;
	}
int NetTCP::calculate() {
	return 0;
	}


#else

int NetTCP::init() {
	return 0;
	}
void NetTCP::deinit() {
	}
int NetTCP::listen(int port, int (*callback)(NetTCP * )) {
	tw_error("Networking is disabled in this version of TimeWarp");
	return 0;
	}
int NetTCP::connect(void *address, int port) {
	tw_error("Networking is disabled in this version of TimeWarp");
	return 0;
	}
int NetTCP::disconnect(void *address, int port) {
	return 0;
	}
int NetTCP::read2send() {
	return 0;
	}
int NetTCP::read2recv() {
	return 0;
	}
int NetTCP::send(int who, int size, void *data) {
	return 0;
	}
int NetTCP::recv(int who, int min, int max, void *data) {
	return 0;
	}
int NetTCP::calculate() {
	return 0;
	}


#endif
