#include <string.h>

#include "../melee.h"
#include "../scp.h"
#include "../frame.h"

#include "mview.h"
#include "mmain.h"
#include "mcbodies.h"
#include "mshppan.h"
#include "mcontrol.h"
#include "mship.h"


View *view = NULL;
int view_num = -1;

const char num_views = 5;
static char *gcc_sucks_dick[num_views + 1] = 
		{"Planet", "Hero", "Looking", "Enemy", "Enemy_Discrete", NULL};
char **view_name = gcc_sucks_dick;

static Stars *stars = NULL;

void set_view (int type) {
	if (type == -1) type = 0;
	if (type == view_num) return;
	if (view) {
		view->deconstruct();
		delete view;
		view = NULL;
		}
	view_num = type;
	switch (type) {
		case 0:
			view = new View_Planet();
			break;
		case 1:
			view = new View_Hero();
			break;
		case 2:
			view = new View_Looking();
			break;
		case 3:
			view = new View_Enemy();
			break;
		case 4:
			view = new View_Enemy_Discrete();
			break;
		}
	view->construct();
	return;
	}
int view2number(const char *name) {
	if (!name) return -1;
	for (int i = 0; i < num_views; i += 1) {
		if (!strcmp(name, view_name[i])) return i;
		}
	return -1;
	}


typedef struct {
  int      x;
  int      y;
	} StarLocation;
class StarLayer {
	public:
	double scroll_x, scroll_y;
	SpaceSprite *pic;
	int num_stars;
	StarLocation *s;
	double depth;
	StarLayer (SpaceSprite *p, int n) ;
	~StarLayer ();
	void StarLayer::animate(Frame *space);
	void scroll (double dx, double dy);
	};

class Stars {
	double depth;
	int num_pics;
	SpaceSprite **pic;
	int num_layers;
	StarLayer **layer;
	public:
	void set_depth (int i) ;
	Stars();
	~Stars();
	void animate(Frame *space);
	void scroll (double dx, double dy);
	};

StarLayer::StarLayer (SpaceSprite *p, int n) {
	scroll_x = scroll_y = 0;
	pic = p;
	num_stars = n;
	depth = 1.0;
	s = new StarLocation[num_stars];
	for (int i = 0; i < num_stars; i++) {
		s[i].x = (int) ((random() % (int)(X_MAX)) - X_MAX / 2.);
		s[i].y = (int) ((random() % (int)(Y_MAX)) - Y_MAX / 2.);
		}
	}

StarLayer::~StarLayer () {
	delete s;
	}

void StarLayer::scroll (double dx, double dy) {
	scroll_x += depth * dx;
	while (scroll_x > X_MAX) scroll_x -= X_MAX;
	while (scroll_x < 0) scroll_x += X_MAX;
	scroll_y += depth * dy;
	while (scroll_y > Y_MAX) scroll_y -= Y_MAX;
	while (scroll_y < 0) scroll_y += Y_MAX;
	return;
	}

void Stars::set_depth (int d) {
	depth = log(1 - d / 260.0) / log(2);
	for (int i = 0; i < num_layers; i += 1) {
		if (num_layers > 1) {
			layer[i]->depth = pow (2, depth * i / (num_layers-1));
			}
		else layer[i]->depth = pow (2,  depth / 2);
		}
	return;
	}

Stars::Stars() {
	int i;
	depth = 0.5;
	num_pics = 3;
	pic = new SpaceSprite*[num_pics];
	for(i = 0; i < num_pics; i++) {
		pic[i] = new SpaceSprite(&melee[MELEE_STAR + i], 1);
		}
	num_layers = 15;
	layer = new StarLayer*[num_layers];
	for (i = 0; i < num_layers; i += 1) {
		layer[i] = new StarLayer(pic[ i * num_pics / num_layers], 10);
		}
	set_config_file("scp.ini");
	set_depth(get_config_int("SCP", "StarDepth", 192));
	}

Stars::~Stars() {
	int i;
	for(i = 0; i < num_pics; i++) delete pic[i];
	delete pic;
	for(i = 0; i < num_layers; i++) delete layer[i];
	delete layer;
	}

void StarLayer::animate(Frame *space) {
	int i;
	double sx, sy, bx, by, sz;
	sz = space_zoom;
	bx = (view_x - pic->width() * sz) / 2;
	by = (view_y - pic->height() * sz) / 2;
	int tx, ty;
	tx = (int) scroll_x;
	ty = (int) scroll_y;
  for(i = 0; i < num_stars; i += 1) {
		sx = s[i].x + tx;
		sy = s[i].y + ty;

		if (sx > X_MAX/2) sx -= X_MAX;
		if (sy > Y_MAX/2) sy -= Y_MAX;

		pic->animate(sx * sz + bx, sy * sz + by, 0, sz, space);
		}
	return;
	}

void Stars::animate(Frame *space) {
	int i;
  for(i = num_layers - 1; i >= 0; i -= 1) {
		layer[i]->animate(space);
		}
	return;
	}

void Stars::scroll (double dx, double dy) {
	int i;
  for(i = num_layers - 1; i >= 0; i -= 1) {
		layer[i]->scroll(dx, dy);
		}
	return;
	}





double space_zoom = 1./3;
double space_x = 0;
double space_y = 0;
void View::set_view (double x, double y, double zoom, double smooth) {
	static double odx = 0, ody = 0;
  double dx, dy;
  space_x += view_x / 2 / space_zoom;
  space_y += view_y / 2 / space_zoom;
  dx = min_delta( space_x, x, X_MAX);
  dy = min_delta( space_y, y, Y_MAX);
	double dd = fabs(dx - odx) + fabs(dy - ody);
	double r = sqrt(dx * dx + dy * dy);
	odx = dx;
	ody = dy;
	if (dd * space_zoom < 100) {
		r *= space_zoom;
		if (r < 9) {
			dx *= smooth * frame_time / 1000.;
			dy *= smooth * frame_time / 1000.;
			}
		else {
			dx = dx * sqrt(r) * smooth * frame_time / 3000.;
			dy = dy * sqrt(r) * smooth * frame_time / 3000.;
			}
		}
	stars->scroll(dx, dy);
  space_x -= dx;
  space_y -= dy;
	space_x_stars -= dx;
	space_y_stars -= dy;
  space_zoom = zoom;
	if (space_zoom < 0.05) space_zoom = 0.05;
  space_x -= view_x / 2 / space_zoom;
  space_y -= view_y / 2 / space_zoom;
	while (space_x > X_MAX) space_x -= X_MAX;
	while (space_x < 0) space_x += X_MAX;
	while (space_y > Y_MAX) space_y -= Y_MAX;
	while (space_y < 0) space_y += Y_MAX;
	return;
  }

void View::construct() {
	space_x = ::space_x;
	space_y = ::space_y;
	space_zoom = ::space_zoom;
	space_x_stars = space_y_stars = 0;
	return;
	}
void View::deconstruct() {
	return;
	}
void View::init() {
	if (!stars) stars = new Stars();
	return;
	}
void View::deinit() {
	if (stars) {
		delete stars;
		stars = NULL;
		}
	return;
	}
void View::set_depth(int depth) {
	if (stars) stars->set_depth(depth);
	}
void View::calculate() {}
void View::animate() {
	::space_zoom = this->space_zoom;
	::space_x = this->space_x;
	::space_y = this->space_y;
  acquire_screen();
  radar->erase();
  space->erase();
	if (stars) stars->animate(space);
	release_screen();
	int i, col = 4;
	for (i = 0; i < num_local_players; i += 1) {
		Control *c = control[first_local_player + i];
		char *n = c->getTypeName();
//		if (!strcmp(n, "Keyboard") || !strcmp(n, "Joystick") || !strcmp(n, "VegetableBot")) {
		if (!strcmp(n, "Keyboard") || !strcmp(n, "Joystick")) {
			if ((c->num_targets > 1) && c->ship && c->ship->target && !c->ship->target->isAlly(c->ship)) 
				animate_target(c->ship->target, (i%3)*2-2, ((i/3)%3)*2-2, 140 + i, pallete_color[col]);
			col -= 1;
			if (col == 0) col = 7;
			}
		}
  spaceFrame->animate();
	textprintf (space->frame, font, 0, 0, palette_color[15], "%s", debug_string);
	space->add_box(0, 0, view_x, 40);
  acquire_screen();
	for (i = 0; i < num_players; i += 1) {
		if (panel[i]) panel[i]->animate();
		}
	radar->draw();
	space->draw();
	release_screen();
	return;
	}
void View::animate_target(SpaceLocation *t, int dx, int dy, int r, int c) {
	double x, y;
	r = int( r * space_zoom/2);
	x = t->normal_x() - space_x - view_x/2 / space_zoom;
	while (x < -X_MAX/2) x += X_MAX;
	x *= space_zoom;
	x += dx;
	if ((x*2 > -(view_x+r)) && (x*2 < (view_x+r))) {
		y = t->normal_y() - space_y - view_y/2 / space_zoom;
		while (y < -Y_MAX/2) y += Y_MAX;
		y *= space_zoom;
		y += dy;
		if ((y*2 > -(view_y+r*2)) && (y*2 < (view_y+(r*2)))) {
			x += view_x/2;
			y += view_y/2;
			r /= 2;
			vline (space->frame, (int)x, (int)(y)-r*2, (int)(y)-r, c);
			vline (space->frame, (int)x, (int)(y)+r*2, (int)(y)+r, c);
			hline (space->frame, (int)(x)-r*2, (int)y, (int)(x)-r, c);
			hline (space->frame, (int)(x)+r*2, (int)y, (int)(x)+r, c);
			circle (space->frame, (int)x, int(y), (r*3)>>1, c);
		  space->add_box((int)(x-r*2), (int)(y-r*2), (int)(r*4)+1, (int)(r*4)+1);
			}
		}
	return;
	}




void View_Planet::calculate () {
	double a, b;
	a = view_x / double(X_MAX);
	b = view_y / double(Y_MAX);
	if (b < a) a = b;
	set_view(spacePlanet->normal_x(), spacePlanet->normal_y(), a, 1);
	return;
	}



void View_Hero::init() {
	View::init();
	z = ::space_zoom; 
	if (z < 1./6) z = 1./6;
	if (z > 2) z = 2;
	x = ::space_x; 
	y = ::space_y;
	return;
	}
void View_Hero::calculate() {
	if (key[KEY_EQUALS]) z *= 1 + 0.001 * frame_time;
	if (key[KEY_MINUS])  z /= 1 + 0.001 * frame_time;
	if (z < 1./6) z = 1./6;
	if (z > 2) z = 2;
	if (control[hero]->ship) {
		x = control[hero]->ship->normal_x();
		y = control[hero]->ship->normal_y();
		}
	set_view(x, y, z, 1);
	return;
	}



void View_Looking::init() {
	View::init();
	z = ::space_zoom; 
	if (z < 1./6) z = 1./6;
	if (z > 2) z = 2;
	x = ::space_x; 
	y = ::space_y;
	return;
	}
void View_Looking::calculate() {
	if (key[KEY_EQUALS]) z *= 1 + 0.001 * frame_time;
	if (key[KEY_MINUS])  z /= 1 + 0.001 * frame_time;
	if (z < 0.1667) z = 0.1667;
	if (z > 2) z = 2;
	if (control[hero]->ship) {
		x = control[hero]->ship->normal_x();
		y = control[hero]->ship->normal_y();
		x += view_x / z * cos(control[hero]->ship->get_angle() * ANGLE_RATIO) / 6;
		y += view_y / z * sin(control[hero]->ship->get_angle() * ANGLE_RATIO) / 6;
		}
	set_view(x, y, z, 1);
	return;
	}



void View_Enemy::init() {
	View::init();
	x2 = x = ::space_x; 
	y2 = y = ::space_y;
	return;
	}
void View_Enemy::calculate() {
	if (control[hero]->ship) {
		x = control[hero]->ship->normal_x();
		y = control[hero]->ship->normal_y();
		}
	if (control[hero]->active_target >= 0) {
		Ship *t = control[hero]->target[control[hero]->active_target];
		x2 = t->normal_x();
		y2 = t->normal_y();
		}
	double a, b, c, d;
	a = min_delta(x, x2, X_MAX);
	b = min_delta(y, y2, Y_MAX);
	c = view_x / 1.2 / (fabs(a) + 1);
	if (c > 1) c = 1;
	d = view_y / 1.2 / (fabs(b) + 1);
	if (c > d) c = d;
	set_view(
			normalize(x-a/2, X_MAX), 
			normalize(y-b/2, Y_MAX), c, 2);
	return;
	}



void View_Enemy_Discrete::init() {
	View::init();
	x = x2 = ::space_x; 
	y = y2 = ::space_y;
	return;
	}
void View_Enemy_Discrete::calculate() {
	if (control[hero]->ship) {
		x = control[hero]->ship->normal_x();
		y = control[hero]->ship->normal_y();
		}
	if (control[hero]->active_target >= 0) {
		Ship *t = control[hero]->target[control[hero]->active_target];
		x2 = t->normal_x();
		y2 = t->normal_y();
		}
	double a, b, c, d;
	a = min_delta(x, x2, X_MAX);
	b = min_delta(y, y2, Y_MAX);
	c = view_x / 1.2 / (fabs(a) + 1);
	if (c > 1) c = 1;
	d = view_y / 1.2 / (fabs(b) + 1);
	if (c > d) c = d;
	if (c < 0.5) c = 0.25;
	else if (c < 1) c = 0.5;
	set_view(
			normalize(x-a/2, X_MAX), 
			normalize(y-b/2, Y_MAX), c, 2);
	return;
	}

