#ifndef _MELEE_H
#include "../melee.h"
#endif

#ifndef _MVIEW_H
#define _MVIEW_H

extern View *view;
extern int view_num;

extern double space_zoom;
extern double space_x;
extern double space_y;

extern const char num_views;
extern char **view_name;
void set_view (int type) ;
int view2number(const char *name) ;

class Stars;

class View {
	protected:
	double space_x, space_y;
	double space_zoom;
	double space_x_stars, space_y_stars;
	virtual void set_view (double x, double y, double zoom, double smooth) ;
	virtual void animate_target(SpaceLocation *t, int dx, int dy, int r, int c) ;
	public:
	virtual void set_depth (int depth);
	virtual void calculate();
	virtual void animate();
	virtual void construct();
	virtual void deconstruct();
	virtual void init();
	virtual void deinit();
	};

class View_Planet : public View {
	public:
	virtual void calculate();
	};

class View_Hero : public View {
	double x, y, z;
	public:
	virtual void calculate();
	virtual void init();
	};

class View_Looking : public View {
	double x, y, z;
	public:
	virtual void calculate();
	virtual void init();
	};

class View_Enemy : public View {
	double x, y, x2, y2;
	public:
	virtual void calculate();
	virtual void init();
	};

class View_Enemy_Discrete : public View {
	double x, y, x2, y2;
	public:
	virtual void calculate();
	virtual void init();
	};
#endif